// ---------------------------------------------------------------------
//     This software is free, but in the event of publication, 
//     the following notice is applicable:
//
//                    (C) COPYRIGHT 2004 R&D center Elvees.
//
//     The entire notice above must be reproduced on all copies.
//
// ----------------------------------------------------------------------

#include "../../include/mf01_model.h"
#include <fstream>

MF01_model_ &Rx = *Create_MF01_model("RX");

void Setup (){
  Rx.set_dump_file_prefix("Test_");
  Rx.set_dump(1, 1024); //write "length" samples, from "bitmask" points.

  Rx.set_in_fmt(0);  

  //Set HTRD  parameters
  Rx.set_HTRD(1, 3492690148, 0);
  Rx.set_in_type(0);       

  //Set CIC2  parameters   
  Rx.set_DCIC2(0, 0, 0); 

  //Set CICN  parameters   
  Rx.set_DCICN(3, 11, 1, 3);

  //Set DFIR1  parameters   
  int dfir_cf[]={194, 913, 1167, -1609, -5981, -2558, 14493, 32767};
  int i;

  Rx.set_DFIR1_CFG(0, 15, 1, 5, 0);
  for (i=0; i<8; i++) Rx.set_DFIR1_coeff(i, dfir_cf[i]);

  //Set DFIR2  parameters   
  Rx.set_DFIR2_CFG(0, 52, 0, 6, 0);
  Rx.load_DFIR2_from_file("../data/ch_is95r.dat");

  Rx.set_GAIN (16384, 0);
};
  
void main(){ 

  int i, q, count=0, sample=0;

  Rx.Clear();
  Setup();

  ofstream outfile;
  outfile.open("output.dat");

  do{
    do{
      sample=32767*(1-2.0*rand()/RAND_MAX);
    } while(sample>32767||sample<-32767);

    Rx.Put(sample);

    if(Rx.num_available()>0){
      if(Rx.Get(i, q)==1)   outfile<<i<<" "<<q<<endl;
      count++;
    }
  }while(count<1250);

  outfile.close();
};

