// ---------------------------------------------------------------------
//     This software is free, but in the event of publication, 
//     the following notice is applicable:
//
//                    (C) COPYRIGHT 2004 R&D center Elvees.
//
//     The entire notice above must be reproduced on all copies.
//
// ----------------------------------------------------------------------

#include "rx_shell.h"

Source::Source(string name) : module_(name){
  file.open("../data/noise.dat");	
}

Source::~Source(){
  if(file.is_open()) file.close();
}

void Source::Put(int y){
  int in;
  if(!file.eof()) 
    file>>in;

  in_sample_ out_p;
  out_p.I=in;
  out_p.Q=0;
  Out(out_p);
}

////////////////////////////////////////////////////////////////////////////////

Check::Check(string name) : module_(name){	
  file.open("output.dat");	
  count=0;
}

Check::~Check(){
  if(file.is_open()) file.close();
}

void Check::Put(packet_ &pack){
  out_sample_ &in_p=(out_sample_ &) pack;
  file<<in_p.I<<" "<<in_p.Q<<endl;
  count++;
}

